<template>
  <base-card :class="$style.cardWrapper">
    <template #main-content>
      <div :class="$style.productDetailWrapper">
        <base-spacing metric="rem">
          <base-image
            :imgClass="$style.mainProductImage"
            :class="$style.figureClass"
            soruce="/img/product-images/1.jpg"
            alt="hoodie image"
            lazy-load
          ></base-image>
        </base-spacing>
        <base-spacing metric="rem" :style="{ marginRight: 'auto' }" left="1">
          <base-typography type="bold">
            {{ title | capitalize }}</base-typography
          >

          <div :class="$style.priceWrapper">
            <base-spacing>
              <base-typography type="bold" color="primary">
                {{ price | currencyFilter }}</base-typography
              >
            </base-spacing>
          </div>
        </base-spacing>

        <base-spacing y="0.1" :class="$style.actionWrapper">
          <base-spacing right="0.5">
            <base-button
              theme="transparent"
              :style="{ minWidth: 'auto' }"
              @click="handleIncreaseAndDecreaseQantity('increase')"
            >
              <base-icon
                size="1.2"
                color="primary"
                name="plus-circle"
              ></base-icon>
            </base-button>
          </base-spacing>
          <base-typography fontSize="1rem" type="bold" color="primary">
            {{ quantity }}</base-typography
          >

          <base-spacing left="0.5">
            <base-button
              theme="transparent"
              :style="{ minWidth: 'auto' }"
              @click="handleIncreaseAndDecreaseQantity('decrease')"
              :disabled="quantity === 0"
            >
              <base-icon
                size="1.2"
                color="primary"
                name="minus-circle"
              ></base-icon>
            </base-button>
          </base-spacing>
        </base-spacing>
      </div>
    </template>
  </base-card>
</template>

<script lang="ts">
import Vue from "vue";
import { createNamespacedHelpers } from "vuex";
import MutationTypes from "@/store/modules/cart/mutation-types";

const { mapMutations } = createNamespacedHelpers("cart");
// components
import BaseSpacing from "@/components/base/BaseSpacing/index.vue";
import BaseTypography from "@/components/base/BaseTypography/index.vue";
import BaseCard from "@/components/base/BaseCard/index.vue";
import BaseImage from "@/components/base/BaseImage/index.vue";
import BaseButton from "@/components/base/BaseButton/index.vue";
import BaseIcon from "@/components/base/BaseIcon/index.vue";

// filters
import currencyFilter from "@/filters/price";

export default Vue.extend({
  name: "AddedProductListItem",
  components: {
    BaseIcon,
    BaseCard,
    BaseImage,
    BaseSpacing,
    BaseTypography,
    BaseButton
  },
  filters: {
    currencyFilter
  },
  props: {
    title: {
      type: String,
      required: true
    },
    price: {
      type: Number,
      required: false
    },
    image: {
      type: String,
      required: false
    },
    id: {
      type: Number,
      required: false
    },
    quantity: {
      type: Number,
      required: false
    }
  },
  methods: {
    ...mapMutations({
      changeProductInCartQuantity: MutationTypes.CHANGE_ITEM_IN_CART
    }),

    handleIncreaseAndDecreaseQantity: function(action: string) {
      this.changeProductInCartQuantity({ id: this.id, type: action });
    }
  }
});
</script>

<style module lang="scss">
.cardWrapper {
  width: 100%;
  margin: 0.3rem;
}
.figureClass {
  max-width: 400px;
}
.actionWrapper {
  composes: display--flex;
  composes: align-items--center;
}
.mainProductImage {
  width: 100px;
  composes: border-radius--default;
}

.productDetailWrapper {
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--space-between;
}

.priceWrapper {
  composes: display--flex;
}

@media screen and (max-width: $device-size--mobile-large) {
  .cardWrapper {
    width: 100%;
  }
}
</style>
